﻿using System.Collections.ObjectModel;
using System.Windows;

namespace DataTreeFiltering
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<NodeX> NodeXCollection { get; set; }

        public bool IsInMode2 { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            NodeXCollection = new ObservableCollection<NodeX>();
            NodeX root = new NodeX();
            root.Name = "root node";
            root.IsSpecialNode = true;
            root.Nodes = new ObservableCollection<NodeX>();

            NodeX child1 = new NodeX();
            child1.Name = "child 1";
            child1.IsSpecialNode = false;
            child1.Nodes = new ObservableCollection<NodeX>();

            NodeX child4 = new NodeX();
            child4.Name = "child 4";
            child4.IsSpecialNode = false;
            child4.Nodes = new ObservableCollection<NodeX>();

            root.Nodes.Add(child1);
            root.Nodes.Add(child4);

            NodeX child2 = new NodeX();
            child2.Name = "child 2";
            child2.IsSpecialNode = false;
            child2.Nodes = new ObservableCollection<NodeX>();

            NodeX child3 = new NodeX();
            child3.Name = "child 3";
            child3.IsSpecialNode = false;
            child3.Nodes = new ObservableCollection<NodeX>();

            child2.Nodes.Add(child3);

            child1.Nodes.Add(child2);

            NodeXCollection.Add(root);

            this.DataContext = this;
        }

        private void SwitchMode(object sender, RoutedEventArgs e)
        {
            IsInMode2 = !IsInMode2;
            if (IsInMode2)
            {
                foreach (var nodeX in NodeXCollection[0].Nodes)
                {
                    SetSpecialNode(nodeX, true);
                }
            }
            else
            {
                foreach (var nodeX in NodeXCollection[0].Nodes)
                {
                    SetSpecialNode(nodeX, false);
                }
            }
        }

        private void SetSpecialNode(NodeX node, bool special)
        {
            node.IsSpecialNode = special;
            foreach (var nodeX in node.Nodes)
            {
                nodeX.IsSpecialNode = special;
                SetSpecialNode(nodeX, special);
            }
        }
    }

    public class NodeX
    {
        public string Name { get; set; }

        public ObservableCollection<NodeX> Nodes{get; set;}

        public bool IsSpecialNode {get;set;}
    }
}
